100 ! This program benchmarks various ways of
110 ! writing and reading data.
120 ! The default is to write and read 128 kB,
130 ! with 512 x 256 bytes records
140 ! Currently supported methods:
150 ! 1) EBTKS emulated Floppy drive mounted
160 !    as :D300 using PRINT# and READ#
190 ! 3) EBTKS Native file system using SDWRITE
200 !    SDREAD
210 ! 4) Real HP9121 (SS/SD) Floppy drive mounted
220 !    as :D700 using PRINT# and READ#
230 !    Requires HPIB Interface.
240 ! 5) EBTKS emulated Floppy drive mounted as
250 !    :D301 using WSECTOR and RSECTOR
260 ! 6) EBTKS emulated Tape drive mounted as :T
270 !    using PRINT# and READ#
280 ! 7) Real Tape drive: left as an exercise for
290 !    someone with a working tape drive.
300 !
350 ! To disable the real floppy test, delete lines 1240 TO 1260
360 K9=128 @ ! SET K9 TO NUMBER OF KB TO BE WRITTEN/READ
365 !          K8 is used to hold K9 during tape tests, which
366 !          always use 8 kB
370 DIM B1$[256],B2$[256],B3$[253],D1$[50]
380 ! Create text strings of 256 and 253 characters
390 B1$=""
400 B2$=""
410 FOR I=1 TO 16
420 B2$=B2$&"ABCD1234EFGH5678"
430 NEXT I
440 B3$=B2$[4]
1000 !
1010 DISP @ DISP "TEST EBTKS EMULATED FLOPPY DISK ON :D300"
1020 F1$="TDATA:D300"
1030 GOSUB 2000
1040 !
1190 !
1200 DISP @ DISP "TEST EBTKS NATIVE SD CARD DIRECT ACCESS KEYWORDS"
1210 F1$="BENCH_DATA.DAT"
1220 GOSUB 3000
1230 !
1240 DISP @ DISP "TEST REAL HP9121 FLOPPY SSSD FLOPPY DISK"
1250 F1$="TDATA:D700"
1260 GOSUB 2000
1270 !
1280 DISP @ DISP "TEST EBTKS EMULATED FLOPPY DISK ON"
1290 DISP ":D301 with WSECTOR and RSECTOR"
1300 F1$=":D301"
1310 GOSUB 2500
1320 !
1330 DISP @ DISP "TEST EBTKS EMULATED TAPE DRIVE ON :T"
1332 K8=K9
1334 K9=8 @ ! Tape test is always 8 kB
1340 F1$="TDATA:T"
1350 GOSUB 2000
1352 K9=K8
1360 !
1500 DISP "DONE" @ STOP
2000 ! WRITE K9 KB TO THE SPECIFIED DRIVE/FILE
2010 DISP "WRITE "&VAL$(K9)&" KB TO "&F1$
2020 CREATE F1$,8,256
2030 ASSIGN# 1 TO F1$
2040 DATETIME D6,D7,D8,S1
2050 FOR I1=1 TO K9/2
2060 FOR I2=1 TO 8
2070 PRINT# 1,I2 ; B3$
2080 NEXT I2
2090 NEXT I1
2100 ASSIGN# 1 TO *
2110 DATETIME D6,D7,D8,S2
2120 DISP "WRITE TO "&F1$&" TOOK ";S2-S1;" SECONDS"
2130 ASSIGN# 1 TO F1$
2140 DISP "READ "&VAL$(K9)&" KB FROM "&F1$
2150 DATETIME D6,D7,D8,S1
2160 FOR I1=1 TO K9/2
2170 FOR I2=1 TO 8
2180 READ# 1,I2 ; B1$
2190 NEXT I2
2200 NEXT I1
2210 ASSIGN# 1 TO *
2220 DATETIME D6,D7,D8,S2
2230 DISP "READ FROM "&F1$&" TOOK ";S2-S1;" SECONDS"
2240 PURGE F1$
2250 RETURN
2500 ! Write K9 kB to the specified MSUS$ (in F1$)
2510 ! starting at sector 50, using WSECTOR
2520 DISP "WRITE "&VAL$(K9)&" KB TO "&F1$&" using WSECTOR"
2530 D1$=MEDIA$(F1$)
2540 UNMOUNT F1$
2550 MOUNT F1$,"/SCRATCH.DSK",1
2560 DATETIME D6,D7,D8,S1
2570 FOR I1=1 TO K9
2580 WSECTOR B2$,I1+50,F1$
2590 NEXT I1
2600 DATETIME D6,D7,D8,S2
2610 DISP "WRITE TO "&F1$&" TOOK ";S2-S1;" SECONDS"
2620 DISP "READ "&VAL$(K9)&" KB FROM "&F1$
2630 DATETIME D6,D7,D8,S1
2640 FOR I1=1 TO K9
2650 RSECTOR B1$,I1+50,F1$
2660 NEXT I1
2670 DATETIME D6,D7,D8,S2
2680 DISP "READ FROM "&F1$&" TOOK ";S2-S1;" SECONDS"
2690 UNMOUNT F1$
2700 MOUNT F1$,D1$,0
2710 SDDEL "/SCRATCH.DSK"
2720 RETURN
3000 ! WRITE K9 KB TO THE SD CARD WITH AUXROM KEYWORDS
3010 DISP "WRITE "&VAL$(K9)&" KB TO A FILE ON THE SD CARD "&F1$
3020 SDOPEN F1$,1,1
3030 DATETIME D6,D7,D8,S1
3040 FOR I1=1 TO K9*4
3050 SDWRITE B2$,1
3060 NEXT I1
3070 SDCLOSE 1
3080 DATETIME D6,D7,D8,S2
3090 DISP "WRITE TO "&F1$&" ON SD CARD TOOK ";S2-S1;" SECONDS"
3100 SDOPEN F1$,0,1
3110 DISP "READ "&VAL$(K9)&" KB FROM SDCARD FILE "&F1$
3120 DATETIME D6,D7,D8,S1
3130 FOR I1=1 TO K9*4
3140 SDREAD B1$,B9,256,1
3150 NEXT I1
3160 SDCLOSE 1
3170 DATETIME D6,D7,D8,S2
3180 DISP "READ FROM SD CARD FILE "&F1$&" TOOK ";S2-S1;" SECONDS"
3190 SDCAT F1$
3200 SDDEL F1$
3210 RETURN
9998 DISP "DONE"
9999 END
